=== debian/changelog ===
xournalpp (1.2.8-1) unstable; urgency=medium
  [ Benjamin Hennion ]

  * Improved the behavior of the selection tools
  * Fixed various visual artifacts
  * Fixed some behavior of Mouse+Keyboard combo devices
  * Fixed filename extension stripping
  * Fixed CLI using relative paths
  * Fixed various crashes
  * Made using GtkSourceView and Plugins proper CMake options
  * Updated translations

  [ Barak A. Pearlmutter ]
  * Remove unnecessary rules-requires-root:no line

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 25 Sep 2025 15:27:07 +0100
