=== debian/watch ===
version=4
https://github.com/xournalpp/@PACKAGE@/tags (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
