## xournalpp 1.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 ## Project related Variables
 ## Also update changelog in debian folder!
 project(xournalpp
-        VERSION 1.2.8
+        VERSION 1.2.10
         DESCRIPTION "Xournal++ - Open source hand note-taking program"
         HOMEPAGE_URL "https://xournalpp.github.io/"
         LANGUAGES CXX C)
