=== debian/changelog ===
xournalpp (1.2.10-1) unstable; urgency=medium

  [ Benjamin Hennion ]
  * New Upstream Version
    - Fixed diplay bug when mixing versions
    - Fixed clipboard issues
    - Fixed dangerous background overriding
    - Fixed image attach mode
    - Updated translations

  [ Barak A. Pearlmutter ]
  * Update debian/watch to version 5

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 11 Dec 2025 10:03:15 +0000
