=== debian/watch ===
version: 5
Source: https://github.com/xournalpp/@PACKAGE@/tags
Matching-Pattern: (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
