=== debian/changelog ===
xournalpp (1.3.0-1) unstable; urgency=medium

  [ Benjamin Hennion ]
  * New Upstream Version
    - PDF exports now preserves the background PDF's inner structure (hyperlink, comments, ...)
    - Grid snapping now follows the displayed grid for all background types
    - New graph background with periodically thicker lines
    - New laser pointer tool, writing ephemeral strokes
    - Allow to use an external editor for LaTeX entries
    - Add the possibility of recoloring the screen output (e.g. for night mode or accessibility)
    - Add the possibility of choosing the PDF marker opacity
    - Configurable behaviour in fullscreen or presentation modes
    - Allow to optionally scroll beyond the page's edges
    - The toolbars can now contain several instances of the same button
    - Major changes in the plugin interface
    - Many smaller new features and bugfixes

  [ Barak A. Pearlmutter ]
  * Fix changelog grammar
  * Tweak debian/watch to reject tag 20131011-alpha

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 16 Dec 2025 10:27:56 +0000
