=== debian/control ===
--- 
+++ 
@@ -11,15 +11,16 @@
 	libgtk-3-dev, libpoppler-glib-dev, libxml2-dev,
 	portaudio19-dev, libsndfile1-dev | libsndfile-dev,
 	liblua5.4-dev,
-	libzip-dev, librsvg2-dev, libgtksourceview-4-dev
+	libzip-dev, librsvg2-dev, libgtksourceview-4-dev,
+	libqpdf-dev (>= 10.6)
 Homepage: https://github.com/xournalpp/xournalpp/
 Vcs-Git: https://salsa.debian.org/debian/xournalpp.git
 Vcs-Browser: https://salsa.debian.org/debian/xournalpp
 
 Package: xournalpp
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: lua-lgi, dvipng
+Depends: ${shlibs:Depends}, ${misc:Depends}, qpdf (>= 10.6)
+Recommends: dvipng
 Suggests: texlive-base, texlive-latex-extra
 Description: Xournal++ - Open source hand note-taking program
  Xournal++ is a hand note-taking software written in C++ with the target of
